--[[
ToDo:
Send talnet spec via whisper/party/raid/bg/guild with /im send name
Hybrid/tank/dps/heals math on talnet spec
Add optoin to alter the specDelay
Syncing with other Instance Minions
Saying the names of your talent trees
Disable if it is a GM whisper
GUI
Class spefic triggers
Displaying of others' talents in friends, guild, and who results
Put telent spec in LFGComment:SetText() when in LFG and not in a group and "" it when join a group
Add some override option for the minimum trigger
setLFGComment to slash command
specDelay to slash command
Use CHARACTER_POINTS_CHANGED and PLAYER_LOGIN
]]


local fnd = _G.string.find
local lower = _G.string.lower
local sub = _G.string.sub
local rep = _G.strreplace
local tostr = _G.tostring
local tonum = _G.tonumber

local specDelay = 300
local setLFGComment = true


function groupCheck() 
	if UnitInRaid'player' then
		return "raid"
	elseif GetNumPartyMembers() > 0 then
		return "party"
	else
		return false
	end	
end


--[[
local waterfall = AceLibrary("Waterfall-1.0")

waterfall:Register('InstanceMinionSpec',
 'title','InstanceMinion: Spec Transmitter',
 'tree', 
 {
   {
     text = "Config",
     id = "Config",
     isOpen = true,
     {
       text = "SubSection",
       id = "Sub",
     },
   },
   {
     text = "More Config",
     id = "More"
   }
 },
 'children', function(id)
   if id == 'Config' then
      waterfall:AddControl(<...>)
      return 'Config Heading'
   elseif id == "SubSection" then
     <...>
   end
 end )

]]








local triggers = {
	"spec",
	"specialization",
	"instance",
	"heal",
	"dps",
	"raid",
	"group",
	"party",
	"lfg",
	"queue",
	"tank",
	"resto",
	"lf.?m",
	"quest",
	
}
local addon = CreateFrame("Frame")

local function pr(msg)
	ChatFrame1:AddMessage(msg,.1,.7,.7)
end



function addon:ADDON_LOADED(name)
	if name == "InstanceMinionSpec" then
		
		
		
		
		
		
	end
end

INSTANCEMINIONSPEC = {
	IMDEB = false,
	IM_SUFIX = "I will reply if I am interested in doing an instance with you.", --This is the sufix 
	IM_TOGGLE = true, --This enables/disables the autoreply true is enabled, false is disabled
	DBVERSION = 1,
}

local function getSpec()
	local topName, topPoint
	local cache = {}
	for i=1,3 do
		cache[i] = {}
		cache[i]["name"], _, cache[i]["points"] = GetTalentTabInfo(i)
	end
	topName = cache[1]["name"]
	topPoint = cache[1]["points"]
	if cache[2]["points"] > tonumber(topPoint) then
		topName = cache[2]["name"]
		topPoint = cache[2]["points"]
	end
	if cache[3]["points"] > tonumber(topPoint) then
		topName = cache[3]["name"]
		topPoint = cache[3]["points"]
	end
	return "I am "..topName.." (" ..  cache[1]["points"] .. "/" ..  cache[2]["points"] .. "/" ..  cache[3]["points"] .. ")"
end

local function getSpecPrint()
	local topName, topPoint
	local cache = {}
	for i=1,3 do
		cache[i] = {}
		cache[i]["name"], _, cache[i]["points"] = GetTalentTabInfo(i)
	end
	topName = cache[1]["name"]
	topPoint = cache[1]["points"]
	if cache[2]["points"] > tonumber(topPoint) then
		topName = cache[2]["name"]
		topPoint = cache[2]["points"]
	end
	if cache[3]["points"] > tonumber(topPoint) then
		topName = cache[3]["name"]
		topPoint = cache[3]["points"]
	end
	return "InstanceMinion: I am a level " .. UnitLevel'player' .. " " .. UnitClass'player' .. ", currently specialized in "..topName.." (" ..  cache[1]["points"] .. "/" ..  cache[2]["points"] .. "/" ..  cache[3]["points"] .. "). "
end


--[[
A reversion of NotIt!, with support for all classes. Support for declaring what instances you are currently interested in. When ask via whisper "instance", "tank", "heal", "dps", "to run", "spec" or other instance keywords, auto-respond IE: "InstanceMinion: I am a level 74 shaman, currently specialized in restoration 0/0/64. I am currently interested in running any mid-70s instance." no more often then x timeframe to the queuer. ]]

local sessionQuerys = {}


function addon:CHAT_MSG_WHISPER(message,sender,language,channelString,target,flags,unknown1,channelNumber,channelName,unknown2,counter)
	if not INSTANCEMINIONSPEC.IM_TOGGLE then return end --Check for on/off switch
	if INSTANCEMINIONSPEC.IMDEB then
		--[[pr("message "..(message   or "nil"))
		pr("sender "..(sender   or "nil"))
		pr("language "..(  language or "nil"))
		pr("channelString "..(channelString   or "nil"))
		pr("target "..(target   or "nil"))
		pr("flags "..(flags   or "nil"))
		pr("unknown1 "..(unknown1   or "nil"))
		pr("channelNumber "..(channelNumber   or "nil"))
		pr("channelName "..(channelName   or "nil"))
		pr("unknown2 "..(unknown2   or "nil"))
		pr("counter "..(counter   or "nil"))]]
	end
	--pr("sender "..sender)
	local localOnly
	if sessionQuerys[sender] then
		if sessionQuerys[sender] > GetTime()  then
			return
		end
	end
	if ( sender == UnitName('player') ) or ( fnd(message, "^(InstanceMinion:).*") ) then --If the message is from the current player or another InstanceMinion, only display the message localay as to prevent bounceback that otherwise can only be disabled by logging out or toggling the on/off switch
		localOnly = true
	end
	local msgToSend =  getSpecPrint().. INSTANCEMINIONSPEC.IM_SUFIX 
	for i=1, #triggers do
		if fnd(lower(message), triggers[i]) then
			if localOnly then
				pr(msgToSend)
			else
				if ChatThrottleLib then
					--pr'ctl'
					ChatThrottleLib:SendChatMessage("NORMAL", "InstanceMinion", sub(msgToSend, 1, 255), "WHISPER", nil, sender )--Cut off any characters after the 255th so the mesage will send
				else
					--pr'no ctl'
					SendChatMessage(sub(msgToSend, 1, 255), "WHISPER", nil, sender )--Cut off any characters after the 255th so the mesage will send
				end
			end
			break
		end
		--pr("i"..i)
		--pr("triggers[i]"..triggers[i])
	end
	
	sessionQuerys[sender] = GetTime() + specDelay
end



SLASH_INSTANCEMINION1 = "/im"
SLASH_INSTANCEMINION2 = "/instanceminion"
SlashCmdList["INSTANCEMINION"] = function( msg )
	local i,j, cmd1, cmd2 = string.find(msg, "^([^ ]+) ?(.*)$")
	--pr("cmd1 "..(cmd1 or "nocmd1"))
	--pr("cmd2 "..(cmd2 or "nocmd2"))
	local tog = ""
	if INSTANCEMINIONSPEC.IM_TOGGLE then
		tog = "Currently on"
	else
		tog = "Currently off"
	end
	pr('InstanceMinion: Spec Transmiter: '..tog)
	cmd1 = lower(cmd1 or "")
	if cmd1 == "" or not cmd1 then
		pr"Key /im help for usage information."

	elseif cmd1 == "toggle" then
		pr'Toggle'
		if INSTANCEMINIONSPEC.IM_TOGGLE then
			pr'Off'
			INSTANCEMINIONSPEC.IM_TOGGLE = false
		else
			pr'On'
			INSTANCEMINIONSPEC.IM_TOGGLE = true
		end
	elseif cmd1 == 'on' then
		pr'On'
		INSTANCEMINIONSPEC.IM_TOGGLE = true
	elseif cmd1 == 'off' then
		pr'Off'
		INSTANCEMINIONSPEC.IM_TOGGLE = false
	elseif cmd1 == 'set' then
		--pr'set'
		local strLen = #getSpecPrint()
		if cmd2 == "default" then
			INSTANCEMINIONSPEC.IM_SUFIX = "I will reply if I am interested in doing an instance with you."
			local currentStr = getSpecPrint() .. INSTANCEMINIONSPEC.IM_SUFIX
			strLen = #currentStr
			pr("Your auto responce message when asked about your spec or instance has been set to \n\n"..currentStr.."\n\n This message is "..strLen.." characters long. Any characters after the 255th will be cut off when your messge is sent.")		
		elseif not cmd2 or cmd2 == "" then
			pr("Use "..(255 - strLen).." or less characters in your setting of your personal message, or the last charaters might be cut off. Your message has not been set; no message defined.")
		else
			local currentStr = getSpecPrint() .. cmd2
			strLen = #currentStr
			pr("Your auto responce message when asked about your spec or instance has been set to \n\n"..currentStr.."\n\n This message is "..strLen.." characters long. Any characters after the 255th will be cut off when your messge is sent.")
			INSTANCEMINIONSPEC.IM_SUFIX = cmd2
		end
	elseif cmd1 == 'use' or cmd1 == 'help' then
		--pr'use or help'
		cmd2 = lower(cmd2)
		if not cmd2 or cmd2 == "" then
			pr'InstanceMinion is an auto-reply mod when one of these patterns are whispred to you: "spec", "specialization", "instance", "heal", "dps", "raid", "group", "party", "lfg", "queue", "tank", "resto", "quest", or "lf.?m".'
			pr'To enable/disable these filters, delete or add the line that contains the filter you want, of if you are not savvy, post a request in the comments of where you downloaded this mod.'
			pr(string.format ('%q','Accepted commands: /{im|instanceminion} {help| toggle|on|off|set|use|current|up|update|whisper}'))
			pr(string.format ('%q','Key /im help {help| toggle|on|off|set|use|current|up|update|whisper} for more information about a command.'))
		elseif cmd2 == "help" then
			pr'/im help'
			pr'Display the help message.'
		elseif cmd2 == "toggle" then
			pr'/im toggle'
			pr'Toggles the auto-response on if it is off, or off if it is on.'
		elseif cmd2 == "on" then
			pr'/im on'
			pr'Toggles the auto-response on.'			
		elseif cmd2 == "off" then
			pr'/im off'
			pr'Toggles the auto-response off.'
		elseif cmd2 == "set" then
			pr'/im set'
			pr('Sets the message to be appended as the sufix after the talent distribution when invoked in an auto-reply. Currently is '..#INSTANCEMINIONSPEC.IM_SUFIX	..' characters long a set to: '..INSTANCEMINIONSPEC.IM_SUFIX)
		elseif cmd2 == "use" then
			pr'/im use'
			pr'Display the help message'
		elseif cmd2 == "current" then
			pr'/im current'
			local currentStr = getSpecPrint() .. INSTANCEMINIONSPEC.IM_SUFIX
			strLen = #currentStr
			pr("Your current auto responce message is currently  set to \n\n"..currentStr.."\n\nThis message is "..strLen.." characters long.")
		elseif cmd2 == "whisper" then
			pr'/im whisper Someone'
			pr("Attempts to whisper Someone your auto-responce.")
		else
			pr'Your help query was not found.'
		end
	elseif cmd1 == 'current' then
		--pr'current'
		local currentStr = getSpecPrint() .. INSTANCEMINIONSPEC.IM_SUFIX
		strLen = #currentStr
		pr("Your current auto responce message is set to \n\n"..currentStr.."\n\nThis message is "..strLen.." characters long.")
	elseif cmd1 == "up" or cmd1 == "update" then
		pr'Updates are at WoWInterface.com under "InstanceMinion"'
	elseif cmd1 == "whisper" then
		if cmd2 == "" or not cmd2 then
			pr'No whisper target specified.'
		else
			local msgToSend = getSpecPrint() .. INSTANCEMINIONSPEC.IM_SUFIX 
			if ChatThrottleLib then
				--pr'ctl'
				ChatThrottleLib:SendChatMessage("NORMAL", "InstanceMinion", sub(msgToSend, 1, 255), "WHISPER", nil, cmd2 )--Cut off any characters after the 255th so the mesage will send
			else
				--pr'no ctl'
				SendChatMessage(sub(msgToSend, 1, 255), "WHISPER", nil, cmd2 )--Cut off any characters after the 255th so the mesage will send
			end
			pr("Sending whisper to "..cmd2..".")
		end
	else
		pr'Unknown command.'
	end
end

function _LFGFrame_Update()
	--pr'_LFGFrame_Update()'
	if not setLFGComment then return end
	local currentComment = LFGComment:GetText()
	--print( LFGComment:GetText())
	if not groupCheck() then
		if ( ( not  currentComment ) or ( currentComment == ""  ) or ( currentComment == CLICK_TO_ENTER_COMMENT ) ) then
			LFGComment:SetText(getSpec());
		end
	end
end

hooksecurefunc("LFGFrame_Update",_LFGFrame_Update)

addon:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)


addon:RegisterEvent("CHAT_MSG_WHISPER")
addon:RegisterEvent("ADDON_LOADED")